<template>
  <div
    class="ui-textarea group relative z-0 flex flex-col text-base lg:text-lg xl:text-xl [&_.ui-form-errors_.errors]:-mt-1 [&_.ui-form-errors_.errors]:rounded-t-none [&_.ui-form-errors_.errors]:border-t-0 [&_.ui-form-errors_.errors]:pt-3 [&_.ui-form-hints_.hints]:mb-1"
    :class="[
      {
        'text-gray-500 [&_.ui-form-hints_.hints]:text-gray-400': disabled,
        'has-errors': hasErrors,
      },
      $attrs.class as string,
    ]"
    :style="$attrs.style as string"
  >
    <slot :label="label" :input-id="inputId" :required="required" name="label">
      <label
        :for="inputId"
        class="leading-relaxed motion-safe:transition-colors"
        :class="{
          'cursor-pointer': !disabled,
          'font-medium group-focus-within:text-violet-700': !hasErrors,
          'font-bold text-red-600 group-focus-within:text-red-700': hasErrors,
        }"
      >
        <span
          v-if="highlighted"
          aria-hidden="true"
          class="-ml-6 -mt-1 inline-block h-0 w-8 overflow-visible align-top text-2xl motion-safe:-ml-8 motion-safe:animate-point-right md:-ml-12 md:w-12 md:text-3xl"
          >👉</span
        >{{ label
        }}<span aria-hidden="true">{{ required ? '*' : '' }}</span></label
      >
    </slot>
    <slot :hints-id="hintsId" :hints="mergedHints" name="hints">
      <ui-form-hints :hints-id="hintsId" :hints="mergedHints" />
    </slot>
    <div class="relative z-10">
      <div
        class="peer pointer-events-none absolute left-2 top-[1.2rem] lg:left-3 [&_svg]:size-[1.25em] [&_svg]:fill-current [&_svg]:motion-safe:transition-colors"
        :class="{
          'text-gray-500 group-focus-within:text-violet-500': !hasErrors,
          'text-red-600 group-focus-within:text-red-700': hasErrors,
        }"
      >
        <slot name="icon" />
      </div>
      <textarea
        :id="inputId"
        :name="inputId"
        v-bind="{ ...filteredAttrs, ...filteredProps }"
        :aria-required="required"
        :aria-describedby="`${hintsId} ${errorsId}`"
        :aria-invalid="hasErrors"
        class="mt-1 block min-h-[3.5rem] w-full rounded border-2 py-3 pl-8 pr-4 text-base shadow focus:outline-none focus:ring-2 focus:ring-opacity-75 peer-empty:pl-4 motion-safe:transition lg:pl-10 lg:text-lg xl:pl-12 xl:text-xl"
        :class="{
          'cursor-not-allowed border-gray-300 bg-gray-50 shadow-none': disabled,
          'border-gray-400 focus:border-violet-700 focus:ring-violet-300 group-hover:border-violet-700':
            !hasErrors && !disabled,
          'focus:border-red-700 focus:ring-red-300 group-hover:border-red-700':
            hasErrors && !disabled,
          'border-red-500': hasErrors,
        }"
      />
    </div>
    <slot :errors-id="errorsId" :errors="parsedErrors" name="errors">
      <ui-form-errors :errors-id="errorsId" :errors="parsedErrors" />
    </slot>
  </div>
</template>

<script lang="ts" setup>
import { computed, useAttrs, PropType } from 'vue'
import { useFormElementErrors, useFormElementId } from '../../composables'
import UiFormHints from './FormHints.vue'
import UiFormErrors from './FormErrors.vue'

defineOptions({
  name: 'UiTextarea',
  inheritAttrs: false,
})

const props = defineProps({
  disabled: {
    type: Boolean,
    default: false,
  },
  hints: {
    type: [String, Array] as PropType<string | string[]>,
    default: '',
  },
  label: {
    type: String,
    default: '',
  },
  name: {
    type: String,
    default: '',
  },
  required: {
    type: Boolean,
    default: false,
  },
  highlighted: {
    type: Boolean,
    default: false,
  },
  highlightedHint: {
    type: String,
    default: '',
  },
  modelValue: {
    type: String,
    default: undefined,
  },
  errors: {
    type: [String, Array, Boolean] as PropType<string | string[] | boolean>,
    default: false,
  },
  touched: {
    type: Boolean,
    default: undefined,
  },
  setTouched: {
    type: Function as PropType<(touched: boolean) => void>,
    default: undefined,
  },
})

const emit = defineEmits(['update:modelValue'])

const filteredProps = computed(() => {
  const {
    name,
    label,
    hints,
    errors,
    modelValue,
    touched,
    setTouched,
    ...filteredProps
  } = props
  return {
    ...filteredProps,
    value: modelValue,
    onInput: ($event: Event) =>
      emit('update:modelValue', ($event.target as HTMLInputElement).value),
  }
})

const filteredAttrs = computed(() => {
  const { class: _, style, onBlur, ...filteredAttrs } = useAttrs()
  return {
    ...filteredAttrs,
    onBlur: ($event: FocusEvent) => {
      typeof props.setTouched === 'function' && props.setTouched(true) // vee-validate blur handler
      typeof onBlur === 'function' && onBlur($event) // native blur handler
    },
  }
})

const mergedHints = computed(() => [
  ...(props.highlightedHint ? [props.highlightedHint] : []),
  ...(Array.isArray(props.hints) ? props.hints : [props.hints]),
])

const { uniqueId, errorsId, hintsId } = useFormElementId(props)

const inputId = computed(() => props.name || uniqueId)

const { hasErrors, parsedErrors } = useFormElementErrors(props)
</script>
